unit UMainForm;

{ Ez a Program az Programozsi Nyelvek 4 trgy honlapjn megtallhat Delphi
  nyelvlersban lv "MDI alkalmazsok ksztse Delphiben" cm fejezethez
  tartoz pldaprogam}


interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, ActnList, StdActns, jpeg, ExtCtrls, UChildForm,UCircle;
  {UChildForm,UCircle - a gyekmekabalakokhoz tartoz Unitjaink, neknk kell kzzel
   felvenni ide a Unit listba }

type
  TMainForm = class(TForm)     // A F ablak form objektum, az rajta lv vizulis objektumokkal
    MainMenu1: TMainMenu;   // Fmen s menk:
    File1: TMenuItem;
    NewElement1: TMenuItem;
    Window1: TMenuItem;
    proba1: TMenuItem;
    ActionList1: TActionList;
    WindowClose1: TWindowClose;
    WindowCascade1: TWindowCascade;
    WindowTileHorizontal1: TWindowTileHorizontal;
    WindowTileVertical1: TWindowTileVertical;
    WindowMinimizeAll1: TWindowMinimizeAll;
    WindowArrange1: TWindowArrange;
    TileVertical1: TMenuItem;
    TileHorizontal1: TMenuItem;
    ArrangeIcons1: TMenuItem;
    MinimizeAll1: TMenuItem;
    NewCircle1: TMenuItem;   // Eddig menk
    Image1: TImage;  // A mozaik httr alapjul szolgl kp (rejtve, mert majd mi direktbe megmondjuk hogy mikor, s hogy rajzolja ki)
    procedure FormCreate(Sender: TObject);  // FormCreate esemny az inicializslsthoz
    procedure NewElement1Click(Sender: TObject); // a menhz tartoz OnClick esemny
    procedure NewCircle1Click(Sender: TObject); // a menhz tartoz OnClick esemny
    // a tbbi menpont(ablakkezelk) kdja elre meg van rva (vagy a gyermekformnl szerepel, lsd ott)
  private
    { Private declarations }
    OldwinProc,NewWinProc : Pointer;    // MDI gyflablak ablakkezel eljrsra mutatnak majd ezek (a rgi,s az j amit helyette fogunk hasznlni)
    procedure NewWinProcedure(var Msg: TMessage); // az j ablakkezel eljrs kdja ebben lesz
  public
    { Public declarations }
    OutCanvas: TCanvas;  // a kirajzols meggyorstshoz hasznljuk, amit erre rajzolunk az kerl majd a kpernyre
  end;

var
  MainForm: TMainForm;     // a fablak objektum vltozja
  counter,counter2 : integer; // gyermekablakok szmt tartjk nyilvn
implementation

{$R *.dfm}


procedure TMainForm.FormCreate(Sender: TObject);
begin
counter:=0;
counter2:=0;
NewWinProc:=MakeObjectInstance(NewWinProcedure);
{ Megfelel formtumra konvertljuk a NewWinProcedure, hogy helyettesteni tudja
  az eredeti ablakkezl eljrst (new Delphi procedure)
}
OldWinProc:=
Pointer (SetWindowLong(ClientHandle, gwl_WndProc,Cardinal (NewWinProc)));
OutCanvas:=TCanvas.Create;
WindowMenu:=Window1;  // melyik menben legyen a megynyitott ablakok listja
end;

procedure TMainForm.NewElement1Click(Sender: TObject);
var
  ChildForm : TChildForm; // egyszer gyermek ablak
begin
  Inc(counter); // szmllt nveljk
  ChildForm := TChildForm.Create(Self);     // ltehozzuk
  ChildForm.Caption:=ChildForm.Caption+ ' ' + IntToStr(counter);
  ChildForm.Show;   // kirajzols a kpernyre
end;



procedure TMainForm.NewCircle1Click(Sender: TObject);
var
  ChildForm : TChildOther; // Circle menvel rendelkez, krrajzols gyermekablak
begin
  Inc(counter2);  // szmllt nveljk
  ChildForm := TChildOther.Create(Self);   // ltehozzuk
  ChildForm.Caption:=ChildForm.Caption+ ' ' + IntToStr(counter) + ' Circle ' ;
  ChildForm.Show;   // kirajzols a kpernyre
end;

procedure TMainForm.NewWinProcedure(var Msg: TMessage);
var
  BmpWidth, BmpHeight,i,j: Integer;
begin
  // alaprtelmezett feldolgozs elszr
  Msg.Result:=CallWindowProc(OldwinProc, ClientHandle,Msg.Msg,MSG.WParam,Msg.LParam);
  // httr jrafests
  if Msg.Msg= wm_EraseBkgnd then        // ha httr trlse ablakzenet jtt (windows)
  begin
    BmpWidth:= MainForm.Image1.Width;  // mozaik alapjul szolgl kp mretei
    BmpHeight:= MainForm.Image1.Height;
    if (BmpWidth<>0) and (BmpHeight<>0) then
    begin
      OutCanvas.Handle:=Msg.WParam;    // gyflablakhoz rendels
      for I:=0 to MainForm.ClientWidth div BmpWidth do
        for J:=0 to MainForm.ClientHeight div BmpHeight do
          begin
            OutCanvas.Draw( I*BmpWidth, J*BmpHeight, MainForm.Image1.Picture.Graphic); // kirajzols
          end;
    end;
  end;  
end;

end.
